package test_queues is
    
    use work.tests.all;

    type queue is private;
    
    function is_empty ( Q : queue ) return boolean;
    
    function is_full ( Q : queue ) return boolean;
    
    procedure add ( Q : inout queue;  item : in test );
    
    procedure remove ( Q : inout queue;  item : out test );

private

    constant max_size : positive := 100;
    
    type queue_array is array (0 to max_size - 1) of test;
    
    type queue is
        record
            head, tail : natural range 0 to max_size - 1;
            size : natural range 0 to max_size;
            the_buffer : queue_array;
        end record queue;
    
end package test_queues;
