package queues is
    generic ( type element_type is private );
    
    type queue is access private;
    
--    impure function new_queue return queue;
    
    procedure make_queue ( Q : out queue );
    
    impure function is_empty ( Q : in queue ) return boolean;
    
    procedure append ( Q : inout queue;  E : in element_type );
    
    procedure extract_head ( Q : inout queue;  E : out element_type );
    
private
        
    type element_node;
    type element_ptr is access element_node;
    
    type element_node is
        record
            next_element : element_ptr;
            value : element_type;
        end record element_node;
    
    type queue is
        record
            head, tail : element_ptr;
        end record queue;
    
end package queues;
